/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-rosgraph-msgs-1.10.12-0raring-20150329-0846/msg/Clock.msg
 *
 */


#ifndef ROSGRAPH_MSGS_MESSAGE_CLOCK_H
#define ROSGRAPH_MSGS_MESSAGE_CLOCK_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace rosgraph_msgs
{
template <class ContainerAllocator>
struct Clock_
{
  typedef Clock_<ContainerAllocator> Type;

  Clock_()
    : clock()  {
    }
  Clock_(const ContainerAllocator& _alloc)
    : clock()  {
    }



   typedef ros::Time _clock_type;
  _clock_type clock;




  typedef boost::shared_ptr< ::rosgraph_msgs::Clock_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rosgraph_msgs::Clock_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Clock_

typedef ::rosgraph_msgs::Clock_<std::allocator<void> > Clock;

typedef boost::shared_ptr< ::rosgraph_msgs::Clock > ClockPtr;
typedef boost::shared_ptr< ::rosgraph_msgs::Clock const> ClockConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rosgraph_msgs::Clock_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rosgraph_msgs::Clock_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rosgraph_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'rosgraph_msgs': ['/tmp/buildd/ros-hydro-rosgraph-msgs-1.10.12-0raring-20150329-0846/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rosgraph_msgs::Clock_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rosgraph_msgs::Clock_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rosgraph_msgs::Clock_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rosgraph_msgs::Clock_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rosgraph_msgs::Clock_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rosgraph_msgs::Clock_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rosgraph_msgs::Clock_<ContainerAllocator> >
{
  static const char* value()
  {
    return "a9c97c1d230cfc112e270351a944ee47";
  }

  static const char* value(const ::rosgraph_msgs::Clock_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xa9c97c1d230cfc11ULL;
  static const uint64_t static_value2 = 0x2e270351a944ee47ULL;
};

template<class ContainerAllocator>
struct DataType< ::rosgraph_msgs::Clock_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rosgraph_msgs/Clock";
  }

  static const char* value(const ::rosgraph_msgs::Clock_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rosgraph_msgs::Clock_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# roslib/Clock is used for publishing simulated time in ROS. \n\
# This message simply communicates the current time.\n\
# For more information, see http://www.ros.org/wiki/Clock\n\
time clock\n\
";
  }

  static const char* value(const ::rosgraph_msgs::Clock_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rosgraph_msgs::Clock_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.clock);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Clock_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rosgraph_msgs::Clock_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rosgraph_msgs::Clock_<ContainerAllocator>& v)
  {
    s << indent << "clock: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.clock);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ROSGRAPH_MSGS_MESSAGE_CLOCK_H
